const int LASER = 8;
const int SENSOR = A0;
const int TRIGGER = 7;

typedef enum {IDLE, READY, IN_PROGRESS, ENDED} ENUM_STATE;

unsigned long tStart = 0;
int lastAnalogRead;
ENUM_STATE currentState = IDLE;

void setup() {
  pinMode(LASER, OUTPUT);
  pinMode(SENSOR, INPUT);
  pinMode(TRIGGER, INPUT_PULLUP);
  Serial.begin(9600);

  Serial.println(F("Urzadzenie gotowe\n"));
  Serial.println(F("Wcisnij i pusc przycisk, aby rozpoczac pomiar."));
  Serial.println(F("Przetnij wiazke lasera aby zakonczyc pomiar."));
  Serial.println(F("---------------------------------------------------"));
}

void loop() {
  if(!digitalRead(TRIGGER)) {
    if(currentState != READY) {
      currentState = READY;
      digitalWrite(LASER, HIGH);
      Serial.println(F("Pusc przycisk, aby rozpoczac pomiar."));
    }
  } else if(currentState == READY) {
    Serial.println(F("Rozpoczeto pomiar."));
    tStart = millis();
    lastAnalogRead = analogRead(SENSOR);
    currentState = IN_PROGRESS;
  }
  
  if(currentState == IN_PROGRESS) {
    int currentAnalogRead = analogRead(SENSOR);
    delay(2);
    if(currentAnalogRead > lastAnalogRead + 100) {
      currentState = ENDED;
    }
    lastAnalogRead = currentAnalogRead;
  }

  if(currentState == ENDED) {
    digitalWrite(LASER, LOW);
    Serial.print(F("Pomiar zakonczony, wynik to: "));
    Serial.print(millis() - tStart);
    Serial.println(F(" ms."));
    Serial.println(F("---------------------------------------------------"));
    currentState = IDLE;
  }
}
